/**************************************************
 holiday.c -- Copyright(c) 1999 Jiro Sekiba <jir@hello.to>
 **************************************************/
#include <time.h>

static int ja_JP_holiday_regular(int,int,int);
static int week(int,int,int);

/* default */
int C_holiday(int year, int month , int day)
{
  return 0;
}

/* holidays of  Japan */
int ja_JP_holiday(int year,int month,int day)
{
  if (ja_JP_holiday_regular(year, month, day))
      return 1;
  else if (week(year, month, day) == 1 &&
           ja_JP_holiday_regular(year, month, day - 1))
      return 1;
  else
      return 0;
}

static int ja_JP_holiday_regular(int year,int month,int day)
{
  if(month == 1 && day == 1) /* new year */
      return 1;
  else if(month == 2 && day == 11) /* Kenkoku Kinenbi */
      return 1;
  else if(month == 4 && day == 29) /* Midori no hi */
      return 1;
  else if(month == 5 && day == 3) /* Kenpo Kinenbi */
      return 1;
  else if(month == 5 && day == 4) /* Kokumin no kyujitsu */
      return 1;
  else if(month == 5 && day == 5) /* Kodomo no hi */
      return 1;
  else if(month == 7 && day == 20 && year < 2004) /* Umi no hi */
      return 1;
  else if(month == 8 && day == 11 && year > 2015) /* Yama no hi */
      return 1;
  else if(month == 9 && day == 15 && year < 2004) /* Keiro no hi */
      return 1;
  else if(month == 11 && day == 3) /* Bunka no hi */
      return 1;
  else if(month == 11 && day == 23) /* Kinro Kansha no hi */
      return 1; 
  else if(month == 12 && day == 23) /* Tenno Tanjobi */
      return 1;
  else if(((month == 1 || month == 10) && 7 < day && day <= 14)
    ||    ((month == 7 || month == 9) && 14 < day && day <= 21))
  {                           /* seijin no hi -- 2nd Monday of January
                                 taiku no hi  -- 2nd Monday of October*/
                              /* Umi no hi    -- 3rd Monday of July
                                 Keirou no hi -- 3rd Monday of September */
    if (week(year, month, day) == 1)
        return 1;
    /*
    else
        return 0;
    */
  }
  if(month == 3 && 1980 < year && year < 2099 )
  {                                 /* shunbun no hi */
    int x;                          /* This is lazy calculation */

    x = (int)(20.8431+0.242194*(year-1980) - (int)((year-1980)/4));
    if(day == x)
        return 1;
    /*
    else
        return 0;
    */
  }
  if(month == 9 && 1980 < year && year < 2099 )
  {                                /* shubun no hi */
    int x;                         /* This is lazy calculation */

    x = (int)(23.2488+0.242194*(year-1980) - (int)((year-1980)/4));
    if(day == x)
        return 1;
    else if(((day+1) == x) && (week(year, month, day) == 2))
        return 1;
    /*
    else
        return 0;
    */
  }
  if(month == 5 && year > 2007 && day == 6
    && ((week(year, month, 1) == 4) || (week(year, month, 1) == 5)))
  {
    return 1;
  }
  return 0;
} /* end  ja_JP_holiday */

/* holidays of  Spain */
int es_ES_holiday(int year,int month,int day)
{
  if(month == 1 && day == 1) /* new year */
      return 1;
  else if(month == 1 && day == 6) /* Epiphany (the Magi feast) */
      return 1;
  else if(month == 5 && day == 1) /* Labour Day */
      return 1;
  else if(month == 10 && day == 12)/*Columbus Day (fiesta de la Hispanidad)*/
      return 1;
  else if(month == 11 && day == 1) /* Saint's Day */
      return 1;
  else if(month == 12 && day == 6) /* Spanish Constitution Day */
      return 1;
  else if(month == 12 && day == 9) /* the Inmaculate Conception */
      return 1;
  else if(month == 12 && day == 25) /* Christmas Day */
      return 1;
  return 0;
} /* end  es_ES_holiday */

static int week(int year,int month,int day)
{
  if ((month == 1) || (month == 2)) {
    year--;
    month += 12;
  }
  return 
    (( year + year/4 - year/100 + year/400 + (13 * month + 8)/5 + day) % 7 );
}
